# vim: set sw=4 ts=4 et:
# Copyright (c) 2009-2012 Pascal Bleser <pascal.bleser@opensuse.org>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.links2linux.org/

%define rev 6509

Name:           handbrake-unstable
Version:        0.9.9.9+%{rev}
Conflicts:      handbrake
# svn://svn.handbrake.fr/HandBrake/trunk#%{rev}
Source:         HandBrake-svn%{rev}.tar.bz2
Release:        1.173
Summary:        Multithreaded Video Transcoder
Source99:       handbrake-unstable-rpmlintrc
Source101:      http://download.handbrake.fr/handbrake/contrib/fdk-aac-v0.1.1-6-gbae4553.tar.bz2
Source102:      http://download.handbrake.fr/handbrake/contrib/cmake-3.0.1.tar.gz
Source103:      http://download.handbrake.fr/handbrake/contrib/libav-v10.1.tar.bz2
Source104:      http://download.handbrake.fr/handbrake/contrib/libdvdnav-5.0.1-0-gaa3659d.tar.gz
Source105:      http://download.handbrake.fr/handbrake/contrib/libdvdread-5.0.0-6-gcb1ae87.tar.gz
Source106:      http://download.handbrake.fr/contrib/libmfx-v2014.tar.bz2
Source107:      http://download.handbrake.fr/contrib/libvpx-v1.3.0.tar.bz2
Source108:      http://download.handbrake.fr/contrib/x265-8768-5e604833c5aa-1.4.tar.bz2
Source109:      http://download.handbrake.fr/handbrake/contrib/libbluray-0.5.0.tar.bz2

Patch0:         HandBrake-0.9.9-no-builddate.patch
Patch1:         handbrake-enable_local_fribidi.patch
URL:            http://handbrake.fr/
Group:          Productivity/Multimedia/Video/Editors and Convertors
License:        GPL-2.0+
BuildRoot:      %{_tmppath}/build-%{name}-%{version}
BuildRequires:  python curl wget subversion
BuildRequires:  libbz2-devel zlib-devel libgudev-1_0-devel
%if 0%{?suse_version} > 1230
BuildRequires:  gtk3-devel >= 3.10
BuildRequires:  gtkhtml-devel
%endif
BuildRequires:  fribidi-devel
BuildRequires:  dbus-1-glib-devel
BuildRequires:  libicu-devel libnotify-devel
%if 0%{?suse_version} <= 1140
BuildRequires:  hal-devel
BuildRequires:  libwebkit-devel
%else
BuildRequires:  libwebkitgtk3-devel
%endif
BuildRequires:  sqlite3-devel libcurl-devel libxslt-devel
BuildRequires:  gstreamer-0_10-devel gstreamer-0_10-plugins-base-devel
BuildRequires:  gcc gcc-c++ make glibc-devel yasm nasm
BuildRequires:  autoconf automake libtool intltool
BuildRequires:  update-desktop-files
BuildRequires:  libvorbis-devel libass-devel x264-devel libmp3lame-devel libtheora-devel
BuildRequires:  libsamplerate-devel

%description
HandBrake is an open-source, GPL-licensed, multiplatform, multithreaded video
transcoder.

%package cli
Summary:        Multithreaded Video Transcoder
Group:          Productivity/Multimedia/Video/Editors and Convertors

%description cli
HandBrake is an open-source, GPL-licensed, multiplatform, multithreaded video
transcoder.

This package contains a command-line interface for Handbrake.

%if 0%{?suse_version} > 1230
%package gtk
Summary:        Multithreaded Video Transcoder
Group:          Productivity/Multimedia/Video/Editors and Convertors

%description gtk
HandBrake is an open-source, GPL-licensed, multiplatform, multithreaded video
transcoder.

This package contains a GTK+ graphical user interface for Handbrake.
%endif

%prep
%if 0%{?rev:1}
%setup -q -n "HandBrake-svn%{rev}"
%else
%setup -q -n "HandBrake-%{version}"
%endif
%patch0 -p1

%if 0%{?suse_version} < 1200
%patch1 -p1
%endif

# Copy 3rd party dependencies into expected locations:
%__mkdir download
for f in \
%{S:101} %{S:102} %{S:103} \
%{S:104} %{S:105} %{S:106}  \
%{S:107} %{S:108} %{S:109}  \
; do
    %__ln_s "$f" download/
done

# check beforehand that the versions match what the
# build system expects:
missing=$PWD/.missing
%__grep -hE '\.FETCH\.url *=' contrib/*/module.defs \
| %__awk -F' =' '{print $2}' \
| while read url; do
f=$(echo "$url" | %__sed 's|^.*/||')
    case $f in
        bzip2*|libiconv*|pthreads*|zlib*) continue ;;
        autoconf*|automake*|libtool*|m4*) continue ;;
        pkg-config*)                      continue ;;
        fontconfig*|freetype*|fribidi*|libass*) continue ;;
        libogg*|libtheora*|libvorbis*|libsamplerate*) continue ;;
        libxml2*)                         continue;;
        x264*|lame*)                      continue ;;
        yasm*)                            continue ;;
        mingw-libgnurx*)                  continue ;;
    esac
    [ -e "download/$f" ] || echo "$url">>"$missing"
done

if test -e "$missing"; then
    echo "ERROR: missing contrib source archives:" >&2
    cat "$missing" >&2
    exit 1
fi

%build
# will be removed when the makefiles are fixed, currently
# fails on openSUSE factory because of --as-needed
export SUSE_ASNEEDED=0

# try to remove build date from binaries... -- seife+obs@b1-systems.com
PKGDATE=$(date -r %{_sourcedir}/%{name}.changes +%Y%m%d)
sed -i -e "s/@BUILD@/$PKGDATE/" make/configure.py

%__mkdir build
./configure \
    --force \
    --build="$PWD/build" \
    --prefix="%{buildroot}%{_prefix}" \
    --strip="/bin/true" \
    --optimize=speed \
%if 0%{?suse_version} <= 1230
    --disable-gtk \
%endif
    --debug=max

pushd build
#### get rid of __DATE__ and __TIME__ in fdk-aac
%__mkdir contrib
%__mkdir contrib/fdkaac
tar -xf %{S:101} -C contrib/fdkaac
find contrib/fdkaac/ -type f | xargs sed -i -e "s/__DATE__/\"$PKGDATE\"/"
find contrib/fdkaac/ -type f | xargs sed -i -e 's/__TIME__/"00:00:00"/'
touch contrib/fdkaac/.stamp.extract
pushd contrib/fdkaac/fdk-aac-v0.1.1-6-gbae4553
autoreconf -fi
popd

%__make libhb/project.h
%__make %{?_smp_mflags}
popd #build

%install
pushd build
%__make install
popd #build

if [ -e %{buildroot}%{_bindir}/ghb ]; then
    %__ln_s ghb "%{buildroot}%{_bindir}/HandBrakeGUI"
fi

%suse_update_desktop_file -r ghb AudioVideo AudioVideoEditing

# -f because it might not be there if built without gtk...
%__rm -f "%{buildroot}%{_datadir}/icons"/*/*.cache

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%files cli
%defattr(-,root,root)
%doc AUTHORS COPYING CREDITS NEWS THANKS
%{_bindir}/HandBrakeCLI

%if 0%{?suse_version} > 1230
%files gtk
%defattr(-,root,root)
%doc AUTHORS COPYING CREDITS NEWS THANKS
%{_bindir}/HandBrakeGUI
%{_bindir}/ghb
%{_datadir}/applications/ghb.desktop
%{_datadir}/icons/*/*/apps/hb-icon.*
/usr/share/locale/*/LC_MESSAGES/ghb.mo
%endif

%changelog
* Sun Nov  9 2014 seife+obs@b1-systems.com
- update to rev 6509
  - bump x265 to version 1.4
  - GUI fixes
  - libhb: enable crc checking during audio parameter probe
* Tue Nov  4 2014 seife+obs@b1-systems.com
- disable build of handbrake-gtk on 12.3 or older (gtk3 is too old)
- refine build dependencies to only require GTK3 on 13.1 or newer
- remove unused patch
- rebase "local fribidi patch" for <= 11.4
* Mon Nov  3 2014 seife+obs@b1-systems.com
- udpate to 6502
- use more system libs, less local built
- remove builddate from binaries
* Sat Oct 20 2012 pascal.bleser@opensuse.org
- update to 4972
* Tue Aug 21 2012 pascal.bleser@opensuse.org
- bump version to 0.9.8, update to 4913
* Mon Aug 20 2012 pascal.bleser@opensuse.org
- update to 4912
* Sun Jul  8 2012 pascal.bleser@opensuse.org
- update to 4819
* Sun Apr 22 2012 pascal.bleser@opensuse.org
- update to 4600
* Fri Mar 30 2012 pascal.bleser@opensuse.org
- bumped to 0.9.7, as 0.9.6 is stable
* Fri Mar 30 2012 pascal.bleser@opensuse.org
- update to 4559
* Sun Feb 12 2012 pascal.bleser@opensuse.org
- update to 4445
* Sun Nov 13 2011 pascal.bleser@opensuse.org
- update to 4345
* Fri Nov  4 2011 pascal.bleser@opensuse.org
- update to 4338
* Fri Oct 28 2011 pascal.bleser@opensuse.org
- re-enable handbrake-enable_local_fribidi.patch on < 12.1
* Thu Oct 27 2011 pascal.bleser@opensuse.org
- update to 4324
* Sun Oct 16 2011 pascal.bleser@opensuse.org
- update to 4294
* Fri Aug 26 2011 pascal.bleser@opensuse.org
- update to 4193
* Mon Aug  8 2011 pascal.bleser@opensuse.org
- update to 4162
* Sat Jul 30 2011 pascal.bleser@opensuse.org
- update to 4144
* Sat Jul  2 2011 pascal.bleser@opensuse.org
- update to 4082
* Wed Mar 23 2011 pascal.bleser@opensuse.org
- update to revision 3876:
  * LinGui: backwards compatibility fix gtk versions prior to 2.22 don't have
    gtk_widget_set/get_realized() func
  * LinGui: remove some deprecated widget properties
  * LinGui: fix incorrect base class in ghbcompositor: "works" with gtk2, but
    causes error in gtk3
  * LinGui: don't use private gtk_marshal_* functions: they are not exported in
    gtk+-3, so create our own marshalers
* Tue Mar 22 2011 pascal.bleser@opensuse.org
- update to revision 3870:
  * many gtk fixes
  * remove legacy %% to RF mapping: although the %% option has been gone for a
    while in the cli and gui's, there were some mappings happening in libhb and
    for preset imports; this removes the last vestages of %% quality mapping
* Sat Mar 19 2011 pascal.bleser@opensuse.org
- update to revision 3853:
  * add mpeg-2 encoding support to libhb, cli, and lingui
  * use TEMP or TEMPDIR environment variables for location of tmp directory;
    falls back to /tmp if neither are set
  * add support for DTS-HD High Resolution Audio for BD streams
* Mon Mar 14 2011 pascal.bleser@opensuse.org
- update to revision 3849:
  * fix 2 pass cfr x264 crash: an error in interjob->vrate calculation lead to
    specifying a different timebase for the 1st and 2nd pass which x264 does
    not allow. This improves the interjob->vrate calculation accuracy and also
    guarantees the timebase is the same on both passes regardless of the
    calculations accuracy.
  * fix source dimensions problem with some mpeg2 streams: was using the
    incorrect field for actual "display" dimensions of video. The field I was
    using is most often used for pan and scan which crops a 16:9 image to fit a
    4:3 display.
* Sat Mar 12 2011 pascal.bleser@opensuse.org
- update to revision 3841:
  * fix potential infinite loop in ffmpeg mpeg-4 b-frame handling
* Sat Mar 12 2011 pascal.bleser@opensuse.org
- update to revision 3840
* Wed Mar  9 2011 pascal.bleser@opensuse.org
- update to revision 3833
- bumped release to 0.9.5+...
* Tue Mar  1 2011 pascal.bleser@opensuse.org
- update to revision 3822
* Sat Dec 18 2010 pascal.bleser@opensuse.org
- update to revision 3711
* Thu Dec  2 2010 pascal.bleser@opensuse.org
- update to revision 3697
* Wed Dec  1 2010 pascal.bleser@opensuse.org
- update to revision 3696
* Fri Nov 27 2009 pascal.bleser@opensuse.org
- update to 0.9.4
* Sun Nov  1 2009 pascal.bleser@opensuse.org
- update to snapshot 2907
* Thu Oct  1 2009 pascal.bleser@opensuse.org
- downgrade to snapshot rev 2845 as per upstream request
- fix version display
- use upstream compiler flags as per upstream request
* Fri Sep 25 2009 pascal.bleser@opensuse.org
- update to rev 2844:
  * [2844] bump libtheora to official 1.1 release
  * [2843] fix srt track stop time; srt stop time was being set to the end of the start chapter instead of the end of the stop chapter
  * [2842] theora: improvements to our theora implementation:
    + support 2-pass mode which is new to theora 1.1
    + set soft target rate control so that single pass abr behaves more like theora 1.0 and doesn't look quite so awful
  * [2841] don't remove srt subs when changing from mkv to mp4
  * [2836] bump x264 to r1271 make changes required by the x264 api change fix some build issues that the x264 bump exposed
  * [2831] fix bug that was causing one sec. of audio to be dropped on many ffmpeg files
* Mon Sep 14 2009 pascal.bleser@opensuse.org
- update to rev 2822:
  * [2821] dvdnav: improved patch that guarantees forward seek moves position forward; the previous patch worked only for SEEK_CUR
  * [2822] allow dvd sources that have no audio
* Sun Sep 13 2009 pascal.bleser@opensuse.org
- update to rev 2815:
  * [2796] set use m4v preference enabled by default
  * [2797] fix PAR issue with DV For some (maybe all) DV, ffmpeg doesn't give us the sample_aspect_ratio in the context; so when it's missing, try looking it up in the AVStream info
  * [2811] improve "auto" audio selection picks the "best" audio given the input codec and output formats
  * [2812] show the correct audio codec in the audio list when it has been changed because of incompatibility with source codec or output format
  * [2813] fix initialization of chapter list when editing queued job Chapter titles the user entered were lost when editing a queued job
  * [2814] fix a Gtk-CRITICAL error when editing chapter names
  * [2815] dvdnav: read error recovery - patch libdvdnav seek to guarantee the position will move forward when making a seek request to a position that is after the current position - when a read error is detected, seek forward and retry
* Sat Sep  5 2009 pascal.bleser@opensuse.org
- new package
